unit ParentMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, IPCThrd;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    MemMapFile: TSharedMem;
  end;

  EWin32Error = class(Exception);

var
  Form1: TForm1;

const
  MemMapFileName = 'SampleMemoryMappedFile';
  MemMapSize = 1000;

implementation

{$R *.DFM}

function LaunchChildApp: THandle;
const
  ChildApp = 'ChildMemoryMappedFile.Exe';
var
  SI: TStartupInfo;
  PI: TProcessInformation;
begin
  GetStartupInfo(SI);
  if not CreateProcess(nil, ChildApp, nil, nil, False,
     0, nil, nil, SI, PI) then
    raise EWin32Error.Create('Unable to launch ' + ChildApp);
  Result := PI.HProcess
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MemMapFile := TSharedMem.Create(MemMapFileName, MemMapSize);
  LaunchChildApp;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  MemMapFile.Free
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if PChar(MemMapFile.Buffer)[0] <> #0 then
    Memo1.Text := StrPas(PChar(MemMapFile.Buffer))
end;

end.
