unit ParentMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    CreateAThread1: TMenuItem;
    LaunchChildApp1: TMenuItem;
    Panel1: TPanel;
    Button1: TButton;
    Label1: TLabel;
    procedure CreateAThread1Click(Sender: TObject);
    procedure LaunchChildApp1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  EWin32Error = class(Exception);

var
  Form1: TForm1;

implementation

uses
  ParentEventUnit;

{$R *.DFM}

procedure TForm1.CreateAThread1Click(Sender: TObject);
begin
  with TTestParentEvent.Create do
    FreeOnTerminate := True
end;

procedure TForm1.LaunchChildApp1Click(Sender: TObject);
const
  ChildApp = 'ChildEvent.Exe';
var
  SI: TStartupInfo;
  PI: TProcessInformation;
begin
  GetStartupInfo(SI);
  if not CreateProcess(nil, ChildApp, nil,
           nil, False, 0, nil, nil, SI, PI) then
    raise EWin32Error.Create('Unable to launch ' + ChildApp);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Event.Signal;
  Event.Reset
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  EventTypes: array[Boolean] of String =
    ('auto-reset', 'manual reset');
begin
  Button1.Caption := Format(
    '&Signal the %s event', [EventTypes[ManualResetFlag]])
end;

end.
