unit PropEG;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TDefaultPropertyExample = class(TComponent)
  private
    FProperty1,
    FProperty2,
    FProperty3: Integer;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Property1: Integer
      read FProperty1 write FProperty1 default 10;
    property Property2: Integer
      read FProperty2 write FProperty2 default 20;
    property Property3: Integer
      read FProperty3 write FProperty3 default 30;
  end;

procedure Register;

implementation

uses
  RTTIUnit;

constructor TDefaultPropertyExample.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  { This is the traditional way of setting }
  { default property values - assign the }
  { value required to each of the underlying }
  { data fields one at a time, e.g. }
  { FProperty1 := 10; }
  { FProperty1 := 20; }
  { FProperty1 := 30; }

  { But here is a neater way as shown in Secrets of Delphi 2 }
  { use the RTTI to do it all automatically. The code }
  { is then the same for each component constructor }
  SetDefaults(Self)
end;

procedure Register;
begin
  RegisterComponents('Samples', [TDefaultPropertyExample]);
end;

end.
 